Loading...
Searching...
No Matches
juce::TreeView Class Reference

## Detailed Description

A tree-view component.

Use one of these to hold and display a structure of TreeViewItem objects.

The documentation for this class was generated from the following file:

- juce_gui_basics/widgets/juce_TreeView.h

Inheritance diagram for juce::TreeView:

## Classes

struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide TreeView drawing functionality. More...

## Public Types

enum | ColourIds { backgroundColourId = 0x1000500 , linesColourId = 0x1000501 , dragAndDropIndicatorColourId = 0x1000502 , selectedItemBackgroundColourId = 0x1000503 , oddItemsColourId = 0x1000504 , evenItemsColourId = 0x1000505 }
| A set of colour IDs to use to change the colour of various aspects of the TreeView. More...
Public Types inherited from juce::Component
enum class | WindowControlKind { client , caption , minimise , maximise , close , sizeTop , sizeLeft , sizeRight , sizeBottom , sizeTopLeft , sizeTopRight , sizeBottomLeft , sizeBottomRight }
| Types of control that are commonly found in windows, especially title-bars. More...
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...
enum class | FocusChangeDirection { unknown , forward , backward }
| Enumeration used by the focusGainedWithDirection() method. More...

## Public Member Functions

| TreeView (const String &componentName={})
| Creates an empty TreeView.
| ~TreeView () override
| Destructor.
void | setRootItem (TreeViewItem *newRootItem)
| Sets the item that is displayed in the TreeView.
TreeViewItem * | getRootItem () const noexcept
| Returns the tree's root item.
void | deleteRootItem ()
| This will remove and delete the current root item.
void | setRootItemVisible (bool shouldBeVisible)
| Changes whether the tree's root item is shown or not.
bool | isRootItemVisible () const noexcept
| Returns true if the root item is visible.
void | setDefaultOpenness (bool isOpenByDefault)
| Sets whether items are open or closed by default.
bool | areItemsOpenByDefault () const noexcept
| Returns true if the tree's items default to being open.
void | setMultiSelectEnabled (bool canMultiSelect)
| This sets a flag to indicate that the tree can be used for multi-selection.
bool | isMultiSelectEnabled () const noexcept
| Returns whether multi-select has been enabled for the tree.
void | setOpenCloseButtonsVisible (bool shouldBeVisible)
| Sets a flag to indicate whether to hide the open/close buttons.
bool | areOpenCloseButtonsVisible () const noexcept
| Returns whether open/close buttons are shown.
void | clearSelectedItems ()
| Deselects any items that are currently selected.
int | getNumSelectedItems (int maximumDepthToSearchTo=-1) const noexcept
| Returns the number of items that are currently selected.
TreeViewItem * | getSelectedItem (int index) const noexcept
| Returns one of the selected items in the tree.
void | moveSelectedRow (int deltaRows)
| Moves the selected row up or down by the specified number of rows.
int | getNumRowsInTree () const
| Returns the number of rows the tree is using, depending on which items are open.
TreeViewItem * | getItemOnRow (int index) const
| Returns the item on a particular row of the tree.
TreeViewItem * | getItemAt (int yPosition) const noexcept
| Returns the item that contains a given y-position relative to the top of the TreeView component.
void | scrollToKeepItemVisible (const TreeViewItem *item)
| Tries to scroll the tree so that this item is on-screen somewhere.
Viewport * | getViewport () const noexcept
| Returns the TreeView's Viewport object.
int | getIndentSize () noexcept
| Returns the number of pixels by which each nested level of the tree is indented.
void | setIndentSize (int newIndentSize)
| Changes the distance by which each nested level of the tree is indented.
TreeViewItem * | findItemFromIdentifierString (const String &identifierString) const
| Searches the tree for an item with the specified identifier.
Component * | getItemComponent (const TreeViewItem *item) const
| Returns the component that currently represents a given TreeViewItem.
std::unique_ptr< XmlElement > | getOpennessState (bool alsoIncludeScrollPosition) const
| Saves the current state of open/closed nodes so it can be restored later.
void | restoreOpennessState (const XmlElement &newState, bool restoreStoredSelection)
| Restores a previously saved arrangement of open/closed nodes.
void | paint (Graphics &) override
| Components can override this method to draw their content.
void | resized () override
| Called when this component's size has been changed.
bool | keyPressed (const KeyPress &) override
| Called when a key is pressed.
void | colourChanged () override
| This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.
void | enablementChanged () override
| Callback to indicate that this component has been enabled or disabled.
bool | isInterestedInFileDrag (const StringArray &) override
| Callback to check whether this target is interested in the set of files being offered.
void | fileDragEnter (const StringArray &, int, int) override
| Callback to indicate that some files are being dragged over this component.
void | fileDragMove (const StringArray &, int, int) override
| Callback to indicate that the user is dragging some files over this component.
void | fileDragExit (const StringArray &) override
| Callback to indicate that the mouse has moved away from this component.
void | filesDropped (const StringArray &, int, int) override
| Callback to indicate that the user has dropped the files onto this component.
bool | isInterestedInDragSource (const SourceDetails &) override
| Callback to check whether this target is interested in the type of object being dragged.
void | itemDragEnter (const SourceDetails &) override
| Callback to indicate that something is being dragged over this component.
void | itemDragMove (const SourceDetails &) override
| Callback to indicate that the user is dragging something over this component.
void | itemDragExit (const SourceDetails &) override
| Callback to indicate that something has been dragged off the edge of this component.
void | itemDropped (const SourceDetails &) override
| Callback to indicate that the user has dropped something onto this component.
std::unique_ptr< AccessibilityHandler > | createAccessibilityHandler () override
| Override this method to return a custom AccessibilityHandler for this component.
Public Member Functions inherited from juce::Component
| Component () noexcept
| Creates a component.
| ~Component () override
| Destructor.
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time.
String | getName () const noexcept
| Returns the name of this component.
virtual void | setName (const String &newName)
| Sets the name of this component.
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID().
void | setComponentID (const String &newID)
| Sets the component's ID string.
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible.
bool | isVisible () const noexcept
| Tests whether the component is visible or not.
virtual void | visibilityChanged ()
| Called when this component's visibility changes.
bool | isShowing () const
| Tests whether this component and all its parents are visible.
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop.
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it.
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop.
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component.
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window.
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised.
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop.
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings.
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings.
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component.
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings.
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings.
int | getX () const noexcept
| Returns the x coordinate of the component's left edge.
int | getY () const noexcept
| Returns the y coordinate of the top of this component.
int | getWidth () const noexcept
| Returns the component's width in pixels.
int | getHeight () const noexcept
| Returns the component's height in pixels.
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge.
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point.
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component.
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box.
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin.
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers.
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin.
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin.
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left.
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left.
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space.
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space.
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate.
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate.
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position.
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position.
void | setTopRightPosition (int x, int y)
| Moves the component to a new position.
void | setTopRightPosition (Point< int >)
| Moves the component to a new position.
void | setSize (int newWidth, int newHeight)
| Changes the size of the component.
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size.
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size.
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size.
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it.
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged.
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre.
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre.
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre.
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent.
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component.
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component.
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component.
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width.
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height.
int | getParentWidth () const noexcept
| Returns the width of the component's parent.
int | getParentHeight () const noexcept
| Returns the height of the component's parent.
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component.
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains.
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index.
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components.
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components.
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID.
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one.
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one.
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already.
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID.
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components.
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index.
void | removeAllChildren ()
| Removes all this component's children.
void | deleteAllChildren ()
| Removes and deletes all of this component's children.
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside.
template<class TargetClass>
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class.
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents.
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children.
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed.
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes.
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component.
virtual WindowControlKind | findControlAtPoint (Point< float >) const
| For components that are added to the desktop, this may be called to determine what kind of control is at particular locations in the window.
virtual void | windowControlClickedClose ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "close" control.
virtual void | windowControlClickedMinimise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "minimise" control.
virtual void | windowControlClickedMaximise ()
| For components that are added to the desktop, this may be called to indicate that the mouse was clicked inside the area of the "maximise" control.
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method.
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags.
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children.
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account.
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one.
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one.
void | repaint ()
| Marks the whole component as needing to be redrawn.
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn.
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn.
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing.
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f, const ImageType &imageType=NativeImageType{})
| Generates a snapshot of part of this component.
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context.
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted.
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted.
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance.
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect.
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component.
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component.
FontOptions | withDefaultMetrics (FontOptions opt) const
| Returns a copy of the FontOptions with the default metrics kind from the component's LookAndFeel.
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting.
void | sendLookAndFeelChange ()
| Calls the methods repaint(), lookAndFeelChanged(), and colourChanged() in this component and all its children recursively.
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent.
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent.
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked.
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on.
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component.
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified.
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports.
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container.
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container.
Component * | findFocusContainer () const
| Returns the focus container for this component.
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component.
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not.
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus.
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus.
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus().
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component.
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component.
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus.
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings.
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component.
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component.
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus.
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline.
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled.
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component.
float | getAlpha () const noexcept
| Returns the component's current transparency level.
void | setAlpha (float newAlpha)
| Changes the transparency of this component.
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component.
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component.
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component.
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated.
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children.
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component.
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component.
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component.
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed.
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down.
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released.
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component.
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved.
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used.
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component.
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component.
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener.
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives.
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener.
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released.
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released.
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusGainedWithDirection (FocusChangeType cause, FocusChangeDirection direction)
| Called to indicate that this component has just acquired the keyboard focus.
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus.
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component.
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component.
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component.
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component.
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component.
virtual void | moved ()
| Called when this component's position has been changed.
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized.
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized.
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings.
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position.
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener.
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component.
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage().
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates.
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state.
void | exitModalState (int returnValue=0)
| Ends a component's modal state.
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one.
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages.
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events.
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component.
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component.
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component.
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number.
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose.
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it.
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method.
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component.
void * | getWindowHandle () const
| Returns the underlying native window handle for this component.
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component.
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component.
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting.
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage().
void | invalidateCachedImageResources ()
| Invalidates cached images, both in the CachedComponentImage (if any) and the image effect state.
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled.
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag.
String | getTitle () const noexcept
| Returns the title text for this component.
void | setTitle (const String &newTitle)
| Sets the title for this component.
String | getDescription () const noexcept
| Returns the description for this component.
void | setDescription (const String &newDescription)
| Sets the description for this component.
String | getHelpText () const noexcept
| Returns the help text for this component.
void | setHelpText (const String &newHelpText)
| Sets the help text for this component.
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients.
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients.
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible.
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component.
Public Member Functions inherited from juce::MouseListener
virtual | ~MouseListener ()=default
| Destructor.
Public Member Functions inherited from juce::SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor.
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object.
String | getTooltip () override
| Returns the tooltip assigned to this object.
Public Member Functions inherited from juce::TooltipClient
virtual | ~TooltipClient ()=default
| Destructor.
Public Member Functions inherited from juce::FileDragAndDropTarget
virtual | ~FileDragAndDropTarget ()=default
| Destructor.
Public Member Functions inherited from juce::DragAndDropTarget
virtual | ~DragAndDropTarget ()=default
| Destructor.
virtual bool | shouldDrawDragImageWhenOver ()
| Overriding this allows the target to tell the drag container whether to draw the drag image while the cursor is over it.

## Additional Inherited Members

Static Public Member Functions inherited from juce::Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor.
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus.
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it.
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation.
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down.
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state.
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal.
Protected Member Functions inherited from juce::SettableTooltipClient
| SettableTooltipClient ()=default

## Member Enums

## ColourIds

enum juce::TreeView::ColourIds

A set of colour IDs to use to change the colour of various aspects of the TreeView.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | A background colour to fill the component with.
linesColourId | The colour to draw the lines with.
dragAndDropIndicatorColourId | The colour to use for the drag-and-drop target position indicator.
selectedItemBackgroundColourId | The colour to use to fill the background of any selected items.
oddItemsColourId | The colour to use to fill the background of the odd numbered items.
evenItemsColourId | The colour to use to fill the background of the even numbered items.

## Constructors and Destructors

## TreeView()

juce::TreeView::TreeView | ( | const String & | componentName = {} | ) |

Creates an empty TreeView.

Once you've got a TreeView component, you'll need to give it something to display, using the setRootItem() method.

Referenced by juce::TreeView::LookAndFeelMethods::areLinesDrawnForTreeView(), and juce::TreeView::LookAndFeelMethods::getTreeViewIndentSize().

## ~TreeView()

juce::TreeView::~TreeView | ( |  | ) |

override

Destructor.

## Member Functions

## setRootItem()

void juce::TreeView::setRootItem | ( | TreeViewItem * | newRootItem | ) |

Sets the item that is displayed in the TreeView.

A tree has a single root item which contains as many sub-items as it needs. If you want the tree to contain a number of root items, you should still use a single root item above these, but hide it using setRootItemVisible().

You can pass nullptr to this method to clear the tree and remove its current root item.

The object passed in will not be deleted by the TreeView, it's up to the caller to delete it when no longer needed. BUT make absolutely sure that you don't delete this item until you've removed it from the tree, either by calling setRootItem (nullptr), or by deleting the tree first. You can also use deleteRootItem() as a quick way to delete it.

References TreeViewItem.

## getRootItem()

TreeViewItem * juce::TreeView::getRootItem | ( |  | ) | const

inline noexcept

Returns the tree's root item.

This will be the last object passed to setRootItem(), or nullptr if none has been set.

References TreeViewItem.

## deleteRootItem()

void juce::TreeView::deleteRootItem | ( |  | ) |

This will remove and delete the current root item.

It's a convenient way of deleting the item and calling setRootItem (nullptr).

## setRootItemVisible()

void juce::TreeView::setRootItemVisible | ( | bool | shouldBeVisible | ) |

Changes whether the tree's root item is shown or not.

If the root item is hidden, only its sub-items will be shown in the TreeView - this lets you make the tree look as if it's got many root items. If it's hidden, this call will also make sure the root item is open (otherwise the TreeView would look empty).

## isRootItemVisible()

bool juce::TreeView::isRootItemVisible | ( |  | ) | const

inline noexcept

Returns true if the root item is visible.

See also
  setRootItemVisible

## setDefaultOpenness()

void juce::TreeView::setDefaultOpenness | ( | bool | isOpenByDefault | ) |

Sets whether items are open or closed by default.

Normally, items are closed until the user opens them, but you can use this to make them default to being open until explicitly closed.

See also
  areItemsOpenByDefault

## areItemsOpenByDefault()

bool juce::TreeView::areItemsOpenByDefault | ( |  | ) | const

inline noexcept

Returns true if the tree's items default to being open.

See also
  setDefaultOpenness

## setMultiSelectEnabled()

void juce::TreeView::setMultiSelectEnabled | ( | bool | canMultiSelect | ) |

This sets a flag to indicate that the tree can be used for multi-selection.

You can always select multiple items internally by calling the TreeViewItem::setSelected() method, but this flag indicates whether the user is allowed to multi-select by clicking on the tree.

By default it is disabled.

See also
  isMultiSelectEnabled

## isMultiSelectEnabled()

bool juce::TreeView::isMultiSelectEnabled | ( |  | ) | const

inline noexcept

Returns whether multi-select has been enabled for the tree.

See also
  setMultiSelectEnabled

## setOpenCloseButtonsVisible()

void juce::TreeView::setOpenCloseButtonsVisible | ( | bool | shouldBeVisible | ) |

Sets a flag to indicate whether to hide the open/close buttons.

See also
  areOpenCloseButtonsVisible

## areOpenCloseButtonsVisible()

bool juce::TreeView::areOpenCloseButtonsVisible | ( |  | ) | const

inline noexcept

Returns whether open/close buttons are shown.

See also
  setOpenCloseButtonsVisible

## clearSelectedItems()

void juce::TreeView::clearSelectedItems | ( |  | ) |

Deselects any items that are currently selected.

## getNumSelectedItems()

int juce::TreeView::getNumSelectedItems | ( | int | maximumDepthToSearchTo = -1 | ) | const

noexcept

Returns the number of items that are currently selected.

If maximumDepthToSearchTo is >= 0, it lets you specify a maximum depth to which the tree will be recursed.

See also
  getSelectedItem, clearSelectedItems

Referenced by juce::FileTreeComponent::getNumSelectedFiles().

## getSelectedItem()

TreeViewItem * juce::TreeView::getSelectedItem | ( | int | index | ) | const

noexcept

Returns one of the selected items in the tree.

Parameters

  index | the index, 0 to (getNumSelectedItems() - 1)

References getSelectedItem(), and TreeViewItem.

Referenced by getSelectedItem().

## moveSelectedRow()

void juce::TreeView::moveSelectedRow | ( | int | deltaRows | ) |

Moves the selected row up or down by the specified number of rows.

References moveSelectedRow().

Referenced by moveSelectedRow().

## getNumRowsInTree()

int juce::TreeView::getNumRowsInTree | ( |  | ) | const

Returns the number of rows the tree is using, depending on which items are open.

See also
  TreeViewItem::getRowNumberInTree()

References getNumRowsInTree().

Referenced by getNumRowsInTree().

## getItemOnRow()

TreeViewItem * juce::TreeView::getItemOnRow | ( | int | index | ) | const

Returns the item on a particular row of the tree.

If the index is out of range, this will return nullptr.

See also
  getNumRowsInTree, TreeViewItem::getRowNumberInTree()

References getItemOnRow(), and TreeViewItem.

Referenced by getItemOnRow().

## getItemAt()

TreeViewItem * juce::TreeView::getItemAt | ( | int | yPosition | ) | const

noexcept

Returns the item that contains a given y-position relative to the top of the TreeView component.

References getItemAt(), and TreeViewItem.

Referenced by getItemAt().

## scrollToKeepItemVisible()

void juce::TreeView::scrollToKeepItemVisible | ( | const TreeViewItem * | item | ) |

Tries to scroll the tree so that this item is on-screen somewhere.

References scrollToKeepItemVisible(), and TreeViewItem.

Referenced by scrollToKeepItemVisible().

## getViewport()

Viewport * juce::TreeView::getViewport | ( |  | ) | const

noexcept

Returns the TreeView's Viewport object.

References getViewport().

Referenced by getViewport().

## getIndentSize()

int juce::TreeView::getIndentSize | ( |  | ) |

noexcept

Returns the number of pixels by which each nested level of the tree is indented.

See also
  setIndentSize

References getIndentSize().

Referenced by getIndentSize().

## setIndentSize()

void juce::TreeView::setIndentSize | ( | int | newIndentSize | ) |

Changes the distance by which each nested level of the tree is indented.

See also
  getIndentSize

References setIndentSize().

Referenced by setIndentSize().

## findItemFromIdentifierString()

TreeViewItem * juce::TreeView::findItemFromIdentifierString | ( | const String & | identifierString | ) | const

Searches the tree for an item with the specified identifier.

The identifier string must have been created by calling TreeViewItem::getItemIdentifierString(). If no such item exists, this will return false. If the item is found, all of its items will be automatically opened.

References findItemFromIdentifierString(), and TreeViewItem.

Referenced by findItemFromIdentifierString().

## getItemComponent()

Component * juce::TreeView::getItemComponent | ( | const TreeViewItem * | item | ) | const

Returns the component that currently represents a given TreeViewItem.

References juce::Component::Component(), getItemComponent(), and TreeViewItem.

Referenced by getItemComponent().

## getOpennessState()

std::unique_ptr< XmlElement > juce::TreeView::getOpennessState | ( | bool | alsoIncludeScrollPosition | ) | const

Saves the current state of open/closed nodes so it can be restored later.

This takes a snapshot of which nodes have been explicitly opened or closed, and records it as XML. To identify node objects it uses the TreeViewItem::getUniqueName() method to create named paths. This means that the same state of open/closed nodes can be restored to a completely different instance of the tree, as long as it contains nodes whose unique names are the same.

Parameters

  alsoIncludeScrollPosition | if this is true, the state will also include information about where the tree has been scrolled to vertically, so this can also be restored

See also
  restoreOpennessState

References getOpennessState().

Referenced by getOpennessState().

## restoreOpennessState()

void juce::TreeView::restoreOpennessState | ( | const XmlElement & | newState,
|  | bool | restoreStoredSelection )

Restores a previously saved arrangement of open/closed nodes.

This will try to restore a snapshot of the tree's state that was created by the getOpennessState() method. If any of the nodes named in the original XML aren't present in this tree, they will be ignored.

If restoreStoredSelection is true, it will also try to re-select any items that were selected in the stored state.

See also
  getOpennessState

References restoreOpennessState().

Referenced by restoreOpennessState().

## paint()

void juce::TreeView::paint | ( | Graphics & | g | ) |

override virtual

Components can override this method to draw their content.

The paint() method gets called when a region of a component needs redrawing, either because the component's repaint() method has been called, or because something has happened on the screen that means a section of a window needs to be redrawn.

Any child components will draw themselves over whatever this method draws. If you need to paint over the top of your child components, you can also implement the paintOverChildren() method to do this.

If you want to cause a component to redraw itself, this is done asynchronously - calling the repaint() method marks a region of the component as "dirty", and the paint() method will automatically be called sometime later, by the message thread, to paint any bits that need refreshing. In JUCE (and almost all modern UI frameworks), you never redraw something synchronously.

You should never need to call this method directly - to take a snapshot of the component you could use createComponentSnapshot() or paintEntireComponent().

Parameters

  g | the graphics context that must be used to do the drawing operations.

See also
  repaint, paintOverChildren, Graphics

Reimplemented from juce::Component.

## resized()

void juce::TreeView::resized | ( |  | ) |

override virtual

Called when this component's size has been changed.

A component can implement this method to do things such as laying out its child components when its width or height changes.

The method is called synchronously as a result of the setBounds or setSize methods, so repeatedly changing a components size will repeatedly call its resized method (unlike things like repainting, where multiple calls to repaint are coalesced together).

If the component is a top-level window on the desktop, its size could also be changed by operating-system factors beyond the application's control.

See also
  moved, setSize

Reimplemented from juce::Component.

## keyPressed()

bool juce::TreeView::keyPressed | ( | const KeyPress & | key | ) |

override virtual

Called when a key is pressed.

When a key is pressed, the component that has the keyboard focus will have this method called. Remember that a component will only be given the focus if its setWantsKeyboardFocus() method has been used to enable this.

If your implementation returns true, the event will be consumed and not passed on to any other listeners. If it returns false, the key will be passed to any KeyListeners that have been registered with this component. As soon as one of these returns true, the process will stop, but if they all return false, the event will be passed upwards to this component's parent, and so on.

The default implementation of this method does nothing and returns false.

See also
  keyStateChanged, getCurrentlyFocusedComponent, addKeyListener

Reimplemented from juce::Component.

## colourChanged()

void juce::TreeView::colourChanged | ( |  | ) |

override virtual

This method is called when a colour is changed by the setColour() method, or when the look-and-feel is changed by the setLookAndFeel() or sendLookAndFeelChange() methods.

See also
  setColour, findColour, setLookAndFeel, sendLookAndFeelChange

Reimplemented from juce::Component.

## enablementChanged()

void juce::TreeView::enablementChanged | ( |  | ) |

override virtual

Callback to indicate that this component has been enabled or disabled.

This can be triggered by one of the component's parent components being enabled or disabled, as well as changes to the component itself.

The default implementation of this method does nothing; your class may wish to repaint itself or something when this happens.

See also
  setEnabled, isEnabled

Reimplemented from juce::Component.

## isInterestedInFileDrag()

bool juce::TreeView::isInterestedInFileDrag | ( | const StringArray & | files | ) |

override virtual

Callback to check whether this target is interested in the set of files being offered.

Note that this will be called repeatedly when the user is dragging the mouse around over your component, so don't do anything time-consuming in here, like opening the files to have a look inside them!

Parameters

  files | the set of (absolute) pathnames of the files that the user is dragging

Returns
  true if this component wants to receive the other callbacks regarding this type of object; if it returns false, no other callbacks will be made.

Implements juce::FileDragAndDropTarget.

## fileDragEnter()

void juce::TreeView::fileDragEnter | ( | const StringArray & | files,
|  | int | x,
|  | int | y )

override virtual

Callback to indicate that some files are being dragged over this component.

This gets called when the user moves the mouse into this component while dragging.

Use this callback as a trigger to make your component repaint itself to give the user feedback about whether the files can be dropped here or not.

Parameters

  files | the set of (absolute) pathnames of the files that the user is dragging
  x | the mouse x position, relative to this component
  y | the mouse y position, relative to this component

Reimplemented from juce::FileDragAndDropTarget.

## fileDragMove()

void juce::TreeView::fileDragMove | ( | const StringArray & | files,
|  | int | x,
|  | int | y )

override virtual

Callback to indicate that the user is dragging some files over this component.

This gets called when the user moves the mouse over this component while dragging. Normally overriding itemDragEnter() and itemDragExit() are enough, but this lets you know what happens in-between.

Parameters

  files | the set of (absolute) pathnames of the files that the user is dragging
  x | the mouse x position, relative to this component
  y | the mouse y position, relative to this component

Reimplemented from juce::FileDragAndDropTarget.

## fileDragExit()

void juce::TreeView::fileDragExit | ( | const StringArray & | files | ) |

override virtual

Callback to indicate that the mouse has moved away from this component.

This gets called when the user moves the mouse out of this component while dragging the files.

If you've used fileDragEnter() to repaint your component and give feedback, use this as a signal to repaint it in its normal state.

Parameters

  files | the set of (absolute) pathnames of the files that the user is dragging

Reimplemented from juce::FileDragAndDropTarget.

## filesDropped()

void juce::TreeView::filesDropped | ( | const StringArray & | files,
|  | int | x,
|  | int | y )

override virtual

Callback to indicate that the user has dropped the files onto this component.

When the user drops the files, this gets called, and you can use the files in whatever way is appropriate.

Note that after this is called, the fileDragExit method may not be called, so you should clean up in here if there's anything you need to do when the drag finishes.

Parameters

  files | the set of (absolute) pathnames of the files that the user is dragging
  x | the mouse x position, relative to this component
  y | the mouse y position, relative to this component

Implements juce::FileDragAndDropTarget.

## isInterestedInDragSource()

bool juce::TreeView::isInterestedInDragSource | ( | const SourceDetails & | dragSourceDetails | ) |

override virtual

Callback to check whether this target is interested in the type of object being dragged.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Returns
  true if this component wants to receive the other callbacks regarding this type of object; if it returns false, no other callbacks will be made.

Implements juce::DragAndDropTarget.

## itemDragEnter()

void juce::TreeView::itemDragEnter | ( | const SourceDetails & | dragSourceDetails | ) |

override virtual

Callback to indicate that something is being dragged over this component.

This gets called when the user moves the mouse into this component while dragging something.

Use this callback as a trigger to make your component repaint itself to give the user feedback about whether the item can be dropped here or not.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

See also
  itemDragExit

Reimplemented from juce::DragAndDropTarget.

## itemDragMove()

void juce::TreeView::itemDragMove | ( | const SourceDetails & | dragSourceDetails | ) |

override virtual

Callback to indicate that the user is dragging something over this component.

This gets called when the user moves the mouse over this component while dragging something. Normally overriding itemDragEnter() and itemDragExit() are enough, but this lets you know what happens in-between.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Reimplemented from juce::DragAndDropTarget.

## itemDragExit()

void juce::TreeView::itemDragExit | ( | const SourceDetails & | dragSourceDetails | ) |

override virtual

Callback to indicate that something has been dragged off the edge of this component.

This gets called when the user moves the mouse out of this component while dragging something.

If you've used itemDragEnter() to repaint your component and give feedback, use this as a signal to repaint it in its normal state.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

See also
  itemDragEnter

Reimplemented from juce::DragAndDropTarget.

## itemDropped()

void juce::TreeView::itemDropped | ( | const SourceDetails & | dragSourceDetails | ) |

override virtual

Callback to indicate that the user has dropped something onto this component.

When the user drops an item this get called, and you can use the description to work out whether your object wants to deal with it or not.

Note that after this is called, the itemDragExit method may not be called, so you should clean up in here if there's anything you need to do when the drag finishes.

Parameters

  dragSourceDetails | contains information about the source of the drag operation.

Implements juce::DragAndDropTarget.

## createAccessibilityHandler()

std::unique_ptr< AccessibilityHandler > juce::TreeView::createAccessibilityHandler | ( |  | ) |

override virtual

Override this method to return a custom AccessibilityHandler for this component.

The default implementation creates and returns a AccessibilityHandler object with an unspecified role, meaning that it will be visible to accessibility clients but without a specific role, action callbacks or interfaces. To control how accessibility clients see and interact with your component subclass AccessibilityHandler, implement the desired behaviours, and return an instance of it from this method in your component subclass.

The accessibility handler you return here is guaranteed to be destroyed before its Component, so it's safe to store and use a reference back to the Component inside the AccessibilityHandler if necessary.

This function should rarely be called directly. If you need to query a component's accessibility handler, it's normally better to call getAccessibilityHandler(). The exception to this rule is derived implementations of createAccessibilityHandler(), which may find it useful to call the base class implementation, and then wrap or modify the result.

See also
  getAccessibilityHandler

Reimplemented from juce::Component.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited